package BPpath.modabrowser;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;

 
/*
 * AddEditBlog.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * author: R. Earle Harris (gnudroider@tuxfamily.org) copyrighted 2014
 *
 */

public class AddEditBlog extends Activity {

	private boolean doubleBackPressedOnce = false;

	public ImageButton CancelBlog;
	public ImageButton CommitBlog;
    public EditText BlogURL;
    public EditText BlogName;
    public TextView LabelURL;
    public TextView LabelName;
    public TextView title;

	private Intent intent = new Intent();
	private String name = "";
	private String url = "";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent i = getIntent();
		name = i.getStringExtra("NAME");
		url = i.getStringExtra("URL");

		setContentView(R.layout.activity_addeditblog);
		findViews();
		BlogName.setText(name);
		BlogURL.setText(url);
	}

	public void commitBlog(View view){
		String blogName = BlogName.getText().toString();
		String blogURL = BlogURL.getText().toString();
		String blog = blogName+"\t"+blogURL;
		intent.putExtra("BLOG",blog);
		setResult(RESULT_OK, intent);
		finish();
	}

	public void cancelBlog(View view){
		cancel();
	}

	public void cancel(){
		setResult(RESULT_CANCELED, intent);
		finish();
	}


	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		CancelBlog = (ImageButton) findViewById(R.id.CancelBlog);
		CommitBlog = (ImageButton) findViewById(R.id.CommitBlog);
		BlogURL = (EditText) findViewById(R.id.BlogURL);
		BlogName = (EditText) findViewById(R.id.BlogName);
		LabelURL = (TextView) findViewById(R.id.LabelURL);
		LabelName = (TextView) findViewById(R.id.LabelName);
	}


	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			setResult(RESULT_CANCELED, intent);
			finish();
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, getResources().getString(R.string.exit_bkbtn) ,
					   Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


}
