package BPpath.modabrowser;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.http.SslError;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.text.ClipboardManager;
import android.text.InputType;
import android.view.Gravity;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;
import android.webkit.SslErrorHandler;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebSettings.PluginState;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.webkit.WebViewDatabase;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.Exception;
import java.lang.NullPointerException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Arrays;
import java.util.List;

 
/*
 * BoilerPlate.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * author: R. Earle Harris (gnudroider@tuxfamily.org) copyrighted 2014
 *
 */
@SuppressLint("SetJavaScriptEnabled")

public class BoilerPlate extends Activity {

	public final static List<String> dnlds = Arrays.asList("apk", "bz2", "gif", "gz", "jpeg",
														   "jpg", "mp3", "ogg", "pdf", 
														   "png", "tgz", "ttf", "zip");

	public String[] userAgents = {
		"",
		"mozilla/5.0 (iphone; cpu iphone os 7_0_2 like mac os x) applewebkit/537.51.1 (khtml, like gecko) version/7.0 mobile/11a501 safari/9537.53",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.1"
	};

	public String[] agents = { "Android", "iPhone", "Firefox" }; 
	public InputMethodManager mgr;

	public final static String SEARCH = "http://duckduckgo.com/html?q=";

	final BoilerPlate mMoDa = this;
	final static int BLOG_POST = 1;
	final static int OPEN_CONTEXT = 0;

	public ClipboardManager clipboard;
	public File download_dir;
	public ImageButton AddNode;
	public ImageButton Copy;
	public ImageButton MoDa;
	public ImageButton Post;
	public ImageButton Refresh;
	public ImageButton Search;
	public ImageButton Toggle;
	public ImageButton Url;
	public LinearLayout DFrame;
	public Button DPos;
	public Button DThree;
	public Button DNeg;
	public EditText DEdit;
	public MoDaView wv;
	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public ProgressBar progress;
	public String currentContext = "contextMoDa";
	public String last_search = "";
	public String sep = "\t"; // must be invalid URL char
	public String userAgent = "";
	public TextView title;
	public int agent = 0;
	public boolean contextTravel = false;
	public boolean cookies = false;
	public boolean cutpaste = false;
	public boolean fan = false;
	public boolean scripting = false;
	public boolean dboole = false; // false = search, true = url

	/**
	 * mWVC Class
	 */

	private class mWVC extends WebViewClient {

		@Override
		public void onPageFinished(WebView view, String url) {
			// fix for blank results on Google search links
			if ("about:blank".equals(url) && (view.getTag() != null)) {
				view.loadUrl(view.getTag().toString()); // get last page
			} else {
				view.setTag(url); // set last page
			}
		}

		@Override
		public void onReceivedSslError (WebView view, SslErrorHandler handler, SslError error) {
			toaster(error.toString(), Toast.LENGTH_LONG);
			toaster(error.toString(), Toast.LENGTH_LONG);
			handler.proceed();
		}


		@Override
		public void onReceivedError(WebView view, int errorCode, String description, 
									String failingUrl) {
			boolean fixed = false;
			try {
				view.loadUrl(view.getTag().toString());
				fixed = true;
			} catch (NullPointerException e) { ; }

			if ((!fixed) && (view.canGoBack())) {
				view.invalidate();
				view.goBack();
				view.goBack();
			}

			//			toaster(description, Toast.LENGTH_SHORT);
		}

		@Override
		public boolean shouldOverrideUrlLoading(WebView view, String url) {

			if (!isOnline())
				return true;

			url = url.trim();
            if (url.startsWith("tel:")) {
                Intent intent = new Intent(Intent.ACTION_DIAL, Uri.parse(url));
                startActivity(intent);
				return true;
            }else if (url.startsWith("mailto:")) {
				String[] emailUri = url.split(":");
				Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
				emailIntent.setType("text/plain");
				emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL,
						new String[] { emailUri[1] });
				startActivity(emailIntent);
				return true;
			} else if (url.contains("play.google.com")) {
				Intent intent = new Intent(Intent.ACTION_VIEW);
				intent.setData(Uri.parse(url));
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK
						| Intent.FLAG_ACTIVITY_CLEAR_TOP
						| Intent.FLAG_ACTIVITY_NO_ANIMATION);
				startActivity(intent);
				return true;
			} else {
				String ext = getExtension(url);
				if (dnlds.contains(ext)) {
					dnld(url);
					return true;
				} else {

					// stop button handling
					MoDa.setBackgroundResource(R.drawable.icon_stop);
					MoDa.setOnClickListener(new View.OnClickListener() {
						@Override
						public void onClick(View v) {
							wv.stopLoading();
							int amt = progress.getProgress();
							if ((amt > 50) && (amt < 80) && (wv.canGoBack())) {
								wv.goBack();
							}
						}
					});

					progress.setProgress(0);
					progress.setVisibility(View.VISIBLE);
					wv.setWebChromeClient(new WebChromeClient() {
						@Override
						public void onProgressChanged(WebView view, int amt) {
							progress.setProgress(amt);
							if (amt == 100) {
								progress.setVisibility(View.GONE);
								MoDa.setBackgroundResource(R.drawable.icon_moda);
								MoDa.setOnClickListener(new View.OnClickListener() {
									@Override
									public void onClick(View v) {
										toggleFan();
									}
								});
							}
						}

					});

					try {
						wv.loadUrl(url);
					} catch (Exception e) {
						toaster(e.getMessage(), Toast.LENGTH_SHORT);
						return false;
					}
					return true;
				}
			}
		}
	}

	/**
	 * MoDa Class
	 */

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mgr = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		clipboard = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
		CookieSyncManager.createInstance(this);
		// prep sdcard
		download_dir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);

		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().requestFeature(Window.FEATURE_PROGRESS);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, 
							 WindowManager.LayoutParams.FLAG_FULLSCREEN);

		setContentView(R.layout.activity_mo_da);

		findViews();//-=-
		DEdit.setOnEditorActionListener(new TextView.OnEditorActionListener() {
				@Override
					public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
					//if (actionId == EditorInfo.IME_ACTION_SEARCH) {
					if (event != null && (event.getKeyCode() == KeyEvent.KEYCODE_ENTER)){
						doPosBtn();
						return true;
					}
					return false;
				}
			});		
		DFrame.setVisibility(View.GONE);

		Url.setBackgroundResource(R.drawable.icon_url);
		Refresh.setBackgroundResource(R.drawable.icon_refresh);
		AddNode.setBackgroundResource(R.drawable.icon_addnode);
		Search.setBackgroundResource(R.drawable.icon_search);
		Toggle.setBackgroundResource(R.drawable.icon_toggle);
		Copy.setBackgroundResource(R.drawable.icon_copy);
		Post.setBackgroundResource(R.drawable.icon_post);

		// Primary Button
		MoDa.setLongClickable(true);
		MoDa.setBackgroundResource(R.drawable.icon_moda);
		MoDa.setOnLongClickListener(new OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) {
				toggleTravel();
				return true;
			}
		});
		MoDa.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				toggleFan();
			}
		});

		CookieManager cookieManager = CookieManager.getInstance();
		CookieSyncManager.getInstance().startSync();
		cookieManager.setAcceptCookie(false);
		cookieManager.removeAllCookie();
		cookieManager.removeSessionCookie();
		CookieSyncManager.getInstance().stopSync();

		WebSettings wvOptions = wv.getSettings();
		userAgents[0] = wvOptions.getUserAgentString();
		wvOptions.setUserAgentString(userAgents[1]);
		agent = agent + 1;
		wvOptions.setJavaScriptEnabled(false);
		wvOptions.setGeolocationEnabled(false);
		wvOptions.setBuiltInZoomControls(true);
		wvOptions.setUseWideViewPort(true);
		wvOptions.setPluginState(PluginState.ON);
		wvOptions.setSupportMultipleWindows(false);
		wvOptions.setSaveFormData(true);
		wvOptions.setMinimumFontSize(12);
		wv.setFocusable(true);
		wv.setFocusableInTouchMode(true);
		wv.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
		wv.setWebViewClient(new mWVC());
		wv.clearCache(true);
		wv.setLongClickable(true);
		wv.setMoDa(this);
		wv.setOnLongClickListener(new OnLongClickListener() {

			@Override
			public boolean onLongClick(View view) {
				if (cutpaste){
					return false;
				} else {
					Intent intent = new Intent(mMoDa, OpenContext.class);
					intent.putExtra("CONTEXT", currentContext);
					intent.putExtra("TRAVEL", contextTravel);
					startActivityForResult(intent, OPEN_CONTEXT);
					return true;
				}
			}
		});


		Intent intent = getIntent();
		String action = intent.getAction();
		String scheme = intent.getScheme();

		if (Intent.ACTION_VIEW.equals(action) && (scheme != null)
				&& scheme.startsWith("http")) {
			String url = intent.getData().toString();
			wv.loadUrl(url);
		} else {
			wv.loadUrl("file:///android_asset/index.html");
		}
		
		new SimpleEula(this).show();
	}

	// Letting activities call wv.loadUrl bypasses mWVC
	public void loadPage4Activity(String url){
		if ((!url.matches("none") && (isOnline()))) {
			MoDa.setBackgroundResource(R.drawable.icon_stop);
			MoDa.setOnClickListener(new View.OnClickListener() {
					@Override
						public void onClick(View v) {
						wv.stopLoading();
						int amt = progress.getProgress();
						if ((amt > 50) && (amt < 80)
							&& (wv.canGoBack())) {
							wv.goBack();
						}
					}
				});
			progress.setProgress(0);
			progress.setVisibility(View.VISIBLE);
			wv.setWebChromeClient(new WebChromeClient() {
					@Override
						public void onProgressChanged(WebView view, int amt) {
						progress.setProgress(amt);
						if (amt == 100) {
							progress.setVisibility(View.GONE);
							MoDa.setBackgroundResource(R.drawable.icon_moda);
							MoDa.setOnClickListener(new View.OnClickListener() {
									@Override
										public void onClick(View v) {
										toggleFan();
									}
								});
						}
					}
				});
			wv.loadUrl(url);
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_OK) {
			if (requestCode == OPEN_CONTEXT) {
				String url = data.getStringExtra("URL");
				currentContext = data.getStringExtra("CONTEXT");
				if (contextTravel){
					wv.reloadContext(currentContext);
				}
				loadPage4Activity(url);
			} else if (requestCode == BLOG_POST) {
				String url = data.getStringExtra("URL");
				loadPage4Activity(url);
			}
		}
	}

	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	public void toggleTravel(){
		contextTravel = !contextTravel;
		wv.toggleTravel(currentContext);
	}


	public void dnld(String url){
		final Dialog dialog = new Dialog(mMoDa);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("Download?");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText(url);
		
		final String f_url = url;
		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Download");
		pos.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
					progress.setProgress(0);
					progress.setVisibility(View.VISIBLE);
					DownloadFile downloadFile = new DownloadFile();
					downloadFile.execute(f_url);
					dialog.dismiss();
				}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Cancel");
		neg.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
					dialog.dismiss();
				}
			});
		
		dialog.show();
	}

	/**
	 *    Fan Methods
	 **/


	public void modaRefresh(View view) {
		wv.reload();
		toggleFan();
		toaster(getResources().getString(R.string.reloading), Toast.LENGTH_SHORT);
	}


	public void toggleClipboard() {
		if (cutpaste){
			cutpaste = false;
			toaster("Longpress for Contexts", Toast.LENGTH_SHORT);
		} else {
			cutpaste = true;
			toaster("Longpress for Clipboard", Toast.LENGTH_SHORT);
		}
	}


	public void toggleAgent() {
		WebSettings wvOptions = wv.getSettings();
		agent = (agent + 1) % 3;
		wvOptions.setUserAgentString(userAgents[agent]);
		toaster("UserAgent: "+ agents[agent], Toast.LENGTH_SHORT);
	}

	public void toggleCookies() {
		CookieManager cookieManager = CookieManager.getInstance();
		CookieSyncManager.getInstance().startSync();
		cookies = !cookies;
		if (cookies){
			cookieManager.setAcceptCookie(true);
			toaster("Cookies On", Toast.LENGTH_SHORT);
		} else {
			cookieManager.setAcceptCookie(false);
			cookieManager.removeAllCookie();
			cookieManager.removeSessionCookie();
			toaster("Cookies off. All cookies deleted.", Toast.LENGTH_SHORT);
		}
		CookieSyncManager.getInstance().stopSync();
	}

	public void modaAddNode(View view) {
		toggleFan();

		String title;
		try {
			title = wv.getTitle();
		} catch (Exception e) {
			title = "";
		}

		if ((title == null) || (title.matches(""))) {
			title = "none";
		}
		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two_edit);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("New Node");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Accept or Rename");
		final EditText e = (EditText) dialog.findViewById(R.id.dEdit);
		e.setInputType(InputType.TYPE_CLASS_TEXT);
		e.setText(title);
		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Set Name");
		pos.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				String name = e.getText().toString();
				String line = name.trim() + sep + wv.getUrl().trim();
				fhandler.writeUniqLineByTokens(currentContext, line, sep);
				dialog.dismiss();
			}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Cancel");
		neg.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				dialog.dismiss();
			}
			});
		
		dialog.show();
	}


	//  doubled up for clear call from dialog
	public void modaSearch(View view) {
		if (isOnline()){
			toggleFan();
			dboole = false;
			DFrame.setVisibility(View.VISIBLE);
			DEdit.requestFocus();
			if(!(mgr==null)) mgr.showSoftInput(DEdit, InputMethodManager.SHOW_FORCED);
			if (clipboard.hasText()){
				DEdit.setText(clipboard.getText());
				clipboard.setText("");
			} else {
				DEdit.setText(last_search);
			}
		}
	}

	public void modaUrl(View view) {
		if (isOnline()) {
			dboole = true;
			String this_page = wv.getOriginalUrl();
			if (!this_page.startsWith("http")) {
				this_page = "";
			}
			toggleFan();
			dboole = true;
			DFrame.setVisibility(View.VISIBLE);
			DEdit.requestFocus();
			if(!(mgr==null)) mgr.showSoftInput(DEdit, InputMethodManager.SHOW_FORCED);
		}
	}

	public void dPosBtn(View view){
		doPosBtn();
	}
	
	public void doPosBtn(){
		String s = DEdit.getText().toString();
		s = s.trim();
		if (!dboole){
			last_search = s;
			s = Uri.encode(s);
			s = SEARCH + s;
		} else {
			if (!s.startsWith("http")) {
				s = "http://" + s;
			}
		}
		wv.setWebViewClient(new mWVC());
		wv.loadUrl(s);
		if (mgr != null){
			mgr.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
		}
		DFrame.setVisibility(View.GONE);
		DEdit.setText("");
	}

	public void dThreeBtn(View view){
		DEdit.setText("");
	}

	public void dNegBtn(View view){
		DEdit.setText("");
		if (mgr != null){
			mgr.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
		}
		DFrame.setVisibility(View.GONE);
	}

	public void modaToggle(View view) {
		toggleFan();
		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_toggle);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("Mo Da Toggles");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Select Toggle. Backbutton Cancels.");

		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("User Agent");
		pos.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				toggleAgent();
				//	dialog.dismiss();
			}
			});

		Button three = (Button) dialog.findViewById(R.id.dThree);
		three.setText("Javascript");
		three.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
					toggleScript();
					//	dialog.dismiss();
				}
			});

		Button four = (Button) dialog.findViewById(R.id.dFour);
		four.setText("Cookies");
		four.setOnClickListener(new OnClickListener() {
				@Override
					public void onClick(View v) {
					toggleCookies();
					//dialog.dismiss();
				}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Two Step");
		neg.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				toggleTwoStep();
				//dialog.dismiss();
			}
			});
		
		Button five = (Button) dialog.findViewById(R.id.dFive);
		five.setText("Clipboard");
		five.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				toggleClipboard();
				//dialog.dismiss();
			}
			});
		
		dialog.show();

	}


	public void toggleTwoStep(){
		wv.toggleTwoStep();
	}

	public void toggleScript(){
		scripting = !scripting;
		WebSettings wvOptions = wv.getSettings();
		wvOptions.setJavaScriptEnabled(scripting);
		wv.reload();
		if (scripting){
			toaster("Javascript On",Toast.LENGTH_SHORT);			
		} else {
			toaster("Javascript Off",Toast.LENGTH_SHORT);			
		}
	}


	public void modaPost(View view) {
		if (isOnline()){
			toggleFan();
			String url = clipboard.getText().toString();
			clipboard.setText("");
			if (! url.matches("")){
				url = url+ "\n\n<br>    ::posted from Mo Da Browser::";
			}
			Intent i = new Intent(this, ChooseBlog.class);
			i.putExtra("LINK",url);
			startActivityForResult(i, BLOG_POST);
		}
	}

	public void modaCopy(View view) {
		String title = wv.getTitle();

		if ((title == null) || (title.matches(""))) {
			title = "MISSING TITLE";
		}

		String url = wv.getUrl();
		url = "\n\n<a href=\""+url+"\">"+title+"</a>";
		clipboard.setText(url);
		toaster("Link to URL copied to clipboard",Toast.LENGTH_SHORT);
		toggleFan();
	}

	private void toggleFan() {
		fan = !fan;
		int i;
		if (fan) {
			i = View.GONE;
		} else {
			i = View.VISIBLE;
		}
		Refresh.setVisibility(i);
		AddNode.setVisibility(i);
		Search.setVisibility(i);
		Toggle.setVisibility(i);
		Url.setVisibility(i);
		Copy.setVisibility(i);
		Post.setVisibility(i);
	}



	/**
	 * download asynctask
	 */
	public class DownloadFile extends AsyncTask<String, Integer, String> {
		@Override
		protected String doInBackground(String... sUrl) {
			URL url;
			try {
				url = new URL(sUrl[0]);
			} catch (MalformedURLException e1) {
				return "Error: Bad URL";
			}
			String fname = url.toString().substring(
					url.toString().lastIndexOf('/') + 1);
			try {
				URLConnection connection = url.openConnection();
				connection.connect();
				int fileLength = connection.getContentLength();

				InputStream input = new BufferedInputStream(
						url.openStream());
				OutputStream output = new FileOutputStream(download_dir
						+ "/" + fname);

				byte data[] = new byte[1024];
				long total = 0;
				int count;
				while ((count = input.read(data)) != -1) {
					total += count;
					publishProgress((int) ((total * 100) / fileLength));
					output.write(data, 0, count);
				}

				output.flush();
				output.close();
				input.close();
			} catch (Exception e) {
				return "ERROR: download failed";
			}
			return fname;
		}

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			progress.setProgress(0);
			progress.setVisibility(View.VISIBLE);
		}

		@Override
		protected void onProgressUpdate(Integer... progress) {
			super.onProgressUpdate(progress);
			getWindow().setFeatureInt(Window.FEATURE_PROGRESS, progress[0]);
		}

		@Override
		protected void onPostExecute(String result) {
			progress.setVisibility(View.GONE);
			toaster(getResources().getString(R.string.downloaded) +
					": " + result, Toast.LENGTH_SHORT);
		}

	}// end asynctask

	/**
	 * Utilities
	 */

	public int indexOfLastSeparator(String filename) {
		if (filename == null)
			return -1;
		int lastUnixPos = filename.lastIndexOf("/");
		int lastWindowsPos = filename.lastIndexOf("\\");
		return Math.max(lastUnixPos, lastWindowsPos);
	}

	public int indexOfExtension(String filename) {
		if (filename == null)
			return -1;
		int extensionPos = filename.lastIndexOf(".");
		int lastSeparator = indexOfLastSeparator(filename);
		return lastSeparator > extensionPos ? -1 : extensionPos;
	}

	public String getExtension(String filename) {
		if (filename == null)
			return null;
		int index = indexOfExtension(filename);
		if (index == -1)
			return "";
		else
			return filename.substring(index + 1);
	}

	public boolean isOnline() {
		ConnectivityManager cm = (ConnectivityManager) getBaseContext()
				.getSystemService(Context.CONNECTIVITY_SERVICE);

		NetworkInfo i = cm.getActiveNetworkInfo();
		if ((i == null) || (!i.isConnected())) {
			toaster(getResources().getString(R.string.isonline), Toast.LENGTH_LONG);
			return false;
		}
		return true;
	}

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		progress = (ProgressBar) findViewById(R.id.progressbar);
		
		Url = (ImageButton) findViewById(R.id.Url);
		Refresh = (ImageButton) findViewById(R.id.Refresh);
		AddNode = (ImageButton) findViewById(R.id.AddNode);
		Search = (ImageButton) findViewById(R.id.Search);
		Copy = (ImageButton) findViewById(R.id.Copy);
		Post = (ImageButton) findViewById(R.id.Post);
		Toggle = (ImageButton) findViewById(R.id.Toggle);

		MoDa = (ImageButton) findViewById(R.id.MoDa);
		wv = (MoDaView) findViewById(R.id.webview);

		DPos = (Button)findViewById(R.id.dPos);
		DThree = (Button)findViewById(R.id.dThree);
		DNeg = (Button)findViewById(R.id.dNeg);
		DEdit = (EditText)findViewById(R.id.dEdit);
		DFrame = (LinearLayout)findViewById(R.id.dFrame);
//-=-
	}

	/**
	 * Android States and Similar
	 */

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed(); // exit by super
			signOut();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}


	private void signOut(){
		WebViewDatabase db=WebViewDatabase.getInstance((Context)this);
		db.clearFormData();
		CookieManager cookieManager = CookieManager.getInstance();
		CookieSyncManager.getInstance().startSync();
		cookieManager.setAcceptCookie(false);
		cookieManager.removeAllCookie();
		cookieManager.removeSessionCookie();
		CookieSyncManager.getInstance().stopSync();
		wv.clearCache(true);
		wv.clearHistory(); 
		wv.clearFormData();
	}

    @Override
    public void onDestroy() {
        super.onDestroy();
		signOut();
    }
}
