package BPpath.modabrowser;

import android.content.Context;
import android.content.res.TypedArray;
import android.util.AttributeSet;

 
/*
 * EdgeEffectListView.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */

public class EdgeEffectListView extends android.widget.ListView {

  public EdgeEffectListView(Context context) {
    this(context, null);
  }

  public EdgeEffectListView(Context context, AttributeSet attrs) {
    this(context, attrs, 0);
  }

  public EdgeEffectListView(Context context, AttributeSet attrs, int defStyle) {
    super(new ContextWrapperEdgeEffect(context), attrs, defStyle);
    init(context, attrs, defStyle);
  }

  private void init(Context context, AttributeSet attrs, int defStyle) {
    int color = context.getResources().getColor(R.color.default_edgeeffect_color);

    if (attrs != null) {
      TypedArray a = context.obtainStyledAttributes(attrs, R.styleable.EdgeEffectView, defStyle, 0);
      color = a.getColor(R.styleable.EdgeEffectView_edgeeffect_color, color);
      a.recycle();
    }
    setEdgeEffectColor(color);
  }

  public void setEdgeEffectColor(int edgeEffectColor) {
    ((ContextWrapperEdgeEffect) getContext()).setEdgeEffectColor(edgeEffectColor);
  }
}
